import { CommandContribution, CommandRegistry, Command, MessageService } from "@theia/core/lib/common";
import { FrontendApplicationContribution } from "@theia/core/lib/browser";
import { Workspace, Languages } from '@theia/languages/lib/browser';
import { WorkspaceService } from '@theia/workspace/lib/browser';
import { DebugConfiguration } from '@theia/debug/lib/common/debug-common';
import { DebugSession } from '@theia/debug/lib/browser/debug-session';
import { DebugSessionManager } from '@theia/debug/lib/browser/debug-session-manager';
import { DebugConfigurationManager } from '@theia/debug/lib/browser/debug-configuration-manager';
import { PythonDebugPreferences } from './python-debug-preferences';
export declare const PythonDebugCommand: {
    id: string;
    label: string;
};
export declare namespace PythonDebugCommands {
    const RUN: Command;
    const DEBUG: Command;
}
export declare namespace PythonDebugSession {
    function is(session: DebugSession): boolean;
}
export declare class PythonDebugFrontendContribution implements FrontendApplicationContribution, CommandContribution {
    protected readonly workspace: Workspace;
    protected readonly languages: Languages;
    protected readonly commands: CommandRegistry;
    protected readonly messages: MessageService;
    protected readonly sessions: DebugSessionManager;
    protected readonly preferences: PythonDebugPreferences;
    protected readonly workspaceService: WorkspaceService;
    protected readonly configurations: DebugConfigurationManager;
    protected readonly suppressedReasons: Set<string>;
    initialize(): void;
    registerCommands(commands: CommandRegistry): void;
    protected runProgram(uri: string, noDebug?: boolean): Promise<void>;
    protected constructDebugConfig(workspaceFolderUri?: string): DebugConfiguration;
    protected dirtyDebugSettings: boolean;
    protected updateDebugSettings(): Promise<void>;
    protected convertLogLevel(commonLogLevel: string): "Error" | "Warning" | "Information";
    protected handleUserNotification({ notificationType, message }: {
        notificationType?: string;
        message: string;
    }): Promise<void>;
}
//# sourceMappingURL=python-debug-frontend-contribution.d.ts.map