"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
// tslint:disable:no-implicit-dependencies
var uri_1 = require("@theia/core/lib/common/uri");
var common_1 = require("@theia/core/lib/common");
var browser_1 = require("@theia/languages/lib/browser");
var browser_2 = require("@theia/workspace/lib/browser");
var debug_session_manager_1 = require("@theia/debug/lib/browser/debug-session-manager");
var debug_configuration_manager_1 = require("@theia/debug/lib/browser/debug-configuration-manager");
var python_debug_preferences_1 = require("./python-debug-preferences");
exports.PythonDebugCommand = {
    id: 'PythonDebug.command',
    label: "Shows a message"
};
var PythonDebugCommands;
(function (PythonDebugCommands) {
    PythonDebugCommands.RUN = {
        id: 'python.runTestNode' // VS Python debugger commands @ 156
    };
    PythonDebugCommands.DEBUG = {
        id: 'python.runTestNode'
    };
})(PythonDebugCommands = exports.PythonDebugCommands || (exports.PythonDebugCommands = {}));
var PythonDebugSession;
(function (PythonDebugSession) {
    function is(session) {
        return session.configuration.type === 'python';
    }
    PythonDebugSession.is = is;
})(PythonDebugSession = exports.PythonDebugSession || (exports.PythonDebugSession = {}));
var PythonDebugFrontendContribution = /** @class */ (function () {
    function PythonDebugFrontendContribution() {
        this.suppressedReasons = new Set();
        this.dirtyDebugSettings = true;
    }
    PythonDebugFrontendContribution.prototype.initialize = function () {
        var _this = this;
        this.sessions.onDidCreateDebugSession(function (session) {
            if (PythonDebugSession.is(session) && _this.sessions.sessions.filter(PythonDebugSession.is).length === 1) {
                _this.updateDebugSettings();
            }
        });
        this.sessions.onDidReceiveDebugSessionCustomEvent(function (_a) {
            var session = _a.session, event = _a.event, body = _a.body;
            if (session.configuration.type !== 'python') {
                return;
            }
            if (event === 'usernotification' && body) {
                return _this.handleUserNotification(body);
            }
        });
        this.sessions.onDidDestroyDebugSession(function (session) {
            if (session.configuration.type === 'python') {
                _this.suppressedReasons.clear();
            }
        });
        var configurations = this.workspace.configurations;
        if (configurations) {
            configurations.onDidChangeConfiguration(function (e) {
                if (e.affectsConfiguration('python.debug')) {
                    _this.dirtyDebugSettings = true;
                    if (_this.sessions.sessions.some(PythonDebugSession.is)) {
                        _this.updateDebugSettings();
                    }
                }
            });
        }
    };
    PythonDebugFrontendContribution.prototype.registerCommands = function (commands) {
        var _this = this;
        commands.registerCommand(PythonDebugCommands.RUN, {
            execute: function (uri) { return _this.runProgram(uri); }
        });
        commands.registerCommand(PythonDebugCommands.DEBUG, {
            execute: function (uri) { return _this.runProgram(uri, false); }
        });
    };
    PythonDebugFrontendContribution.prototype.runProgram = function (uri, noDebug) {
        if (noDebug === void 0) { noDebug = true; }
        return __awaiter(this, void 0, void 0, function () {
            var workspaceFolder, workspaceFolderUri, configuration;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        workspaceFolder = this.workspaceService.getWorkspaceRootUri(new uri_1.default(uri));
                        workspaceFolderUri = workspaceFolder && workspaceFolder.toString();
                        configuration = this.constructDebugConfig(workspaceFolderUri);
                        configuration.noDebug = noDebug;
                        return [4 /*yield*/, this.sessions.start({
                                configuration: configuration,
                                workspaceFolderUri: workspaceFolderUri
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    PythonDebugFrontendContribution.prototype.constructDebugConfig = function (workspaceFolderUri) {
        return ({
            type: 'python',
            name: 'Python: Terminal (integrated)',
            request: 'launch',
            program: '${file}',
            console: 'integratedTerminal'
        });
    };
    PythonDebugFrontendContribution.prototype.updateDebugSettings = function () {
        return __awaiter(this, void 0, void 0, function () {
            var configurations, configuration, logLevel;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.dirtyDebugSettings) {
                            return [2 /*return*/];
                        }
                        this.dirtyDebugSettings = false;
                        configurations = this.workspace.configurations;
                        if (!configurations) return [3 /*break*/, 2];
                        configuration = configurations.getConfiguration('python.debug');
                        logLevel = this.convertLogLevel(configuration.logLevel || '');
                        if (!(configuration.settings && Object.keys(configuration.settings).length)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.commands.executeCommand('vscode.python.updateDebugSettings', JSON.stringify(__assign({}, configuration.settings, { logLevel: logLevel })))];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    PythonDebugFrontendContribution.prototype.convertLogLevel = function (commonLogLevel) {
        // convert common log level to python log level
        switch (commonLogLevel.toLowerCase()) {
            case 'verbose':
                return 'Warning';
            case 'warn':
                return 'Warning';
            case 'error':
                return 'Error';
            case 'info':
                return 'Information';
            default:
                return 'Warning';
        }
    };
    PythonDebugFrontendContribution.prototype.handleUserNotification = function (_a) {
        var notificationType = _a.notificationType, message = _a.message;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(notificationType === 'Error')) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.messages.error(message)];
                    case 1:
                        _b.sent();
                        return [3 /*break*/, 6];
                    case 2:
                        if (!(notificationType === 'Warning')) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.messages.warn(message)];
                    case 3:
                        _b.sent();
                        return [3 /*break*/, 6];
                    case 4: return [4 /*yield*/, this.messages.info(message)];
                    case 5:
                        _b.sent();
                        _b.label = 6;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    __decorate([
        inversify_1.inject(browser_1.Workspace),
        __metadata("design:type", Object)
    ], PythonDebugFrontendContribution.prototype, "workspace", void 0);
    __decorate([
        inversify_1.inject(browser_1.Languages),
        __metadata("design:type", Object)
    ], PythonDebugFrontendContribution.prototype, "languages", void 0);
    __decorate([
        inversify_1.inject(common_1.CommandRegistry),
        __metadata("design:type", common_1.CommandRegistry)
    ], PythonDebugFrontendContribution.prototype, "commands", void 0);
    __decorate([
        inversify_1.inject(common_1.MessageService),
        __metadata("design:type", common_1.MessageService)
    ], PythonDebugFrontendContribution.prototype, "messages", void 0);
    __decorate([
        inversify_1.inject(debug_session_manager_1.DebugSessionManager),
        __metadata("design:type", debug_session_manager_1.DebugSessionManager)
    ], PythonDebugFrontendContribution.prototype, "sessions", void 0);
    __decorate([
        inversify_1.inject(python_debug_preferences_1.PythonDebugPreferences),
        __metadata("design:type", Object)
    ], PythonDebugFrontendContribution.prototype, "preferences", void 0);
    __decorate([
        inversify_1.inject(browser_2.WorkspaceService),
        __metadata("design:type", browser_2.WorkspaceService)
    ], PythonDebugFrontendContribution.prototype, "workspaceService", void 0);
    __decorate([
        inversify_1.inject(debug_configuration_manager_1.DebugConfigurationManager),
        __metadata("design:type", debug_configuration_manager_1.DebugConfigurationManager)
    ], PythonDebugFrontendContribution.prototype, "configurations", void 0);
    PythonDebugFrontendContribution = __decorate([
        inversify_1.injectable()
    ], PythonDebugFrontendContribution);
    return PythonDebugFrontendContribution;
}());
exports.PythonDebugFrontendContribution = PythonDebugFrontendContribution;
//# sourceMappingURL=python-debug-frontend-contribution.js.map