"use strict";
/********************************************************************************
 * Copyright (C) 2018 TypeFox and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT license.
// https://github.com/Microsoft/vscode-java-debug/blob/master/src/configurationProvider.ts adjusted to Theia APIs
// tslint:disable:no-any
var path = require("path");
var _ = require("lodash");
var inversify_1 = require("inversify");
// tslint:disable-next-line:no-implicit-dependencies
var common_1 = require("@theia/core/lib/common");
// tslint:disable-next-line:no-implicit-dependencies
var quick_pick_service_1 = require("@theia/core/lib/common/quick-pick-service");
var vscode_debug_adapter_contribution_1 = require("@theia/debug/lib/node/vscode/vscode-debug-adapter-contribution");
var VSCodePythonDebugCommands;
(function (VSCodePythonDebugCommands) {
    VSCodePythonDebugCommands.VALIDATE_LAUNCH_CONFIG = 'vscode.python.validateLaunchConfig';
    VSCodePythonDebugCommands.START_DEBUG_SESSION = 'vscode.debug.startDebugging';
})(VSCodePythonDebugCommands = exports.VSCodePythonDebugCommands || (exports.VSCodePythonDebugCommands = {}));
var PythonDebugExtensionContribution = /** @class */ (function (_super) {
    __extends(PythonDebugExtensionContribution, _super);
    function PythonDebugExtensionContribution() {
        return _super.call(this, 'python', path.join(__dirname, '../../download/python-debug/extension')) || this;
    }
    PythonDebugExtensionContribution = __decorate([
        inversify_1.injectable(),
        __metadata("design:paramtypes", [])
    ], PythonDebugExtensionContribution);
    return PythonDebugExtensionContribution;
}(vscode_debug_adapter_contribution_1.AbstractVSCodeDebugAdapterContribution));
exports.PythonDebugExtensionContribution = PythonDebugExtensionContribution;
var PythonDebugAdapterContribution = /** @class */ (function (_super) {
    __extends(PythonDebugAdapterContribution, _super);
    function PythonDebugAdapterContribution() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PythonDebugAdapterContribution.prototype.provideDebugConfigurations = function (workspaceFolderUri) {
        return __awaiter(this, void 0, void 0, function () {
            var defaultLaunchConfig, defaultAttachConfig;
            return __generator(this, function (_a) {
                defaultLaunchConfig = {
                    type: 'python',
                    name: 'Python: Terminal (integrated)',
                    request: 'launch',
                    program: '${file}',
                    console: 'integratedTerminal'
                };
                defaultAttachConfig = {
                    type: 'python',
                    name: 'Attach (Remote Debug)',
                    request: 'attach',
                    host: 'localhost',
                    port: '5678',
                    'pathMappings': [
                        {
                            'localRoot': '',
                            'remoteRoot': '.'
                        }
                    ]
                };
                return [2 /*return*/, [defaultLaunchConfig, defaultAttachConfig]];
            });
        });
    };
    PythonDebugAdapterContribution.prototype.constructLaunchConfigName = function (mainClass, projectName, cache) {
        var prefix = 'Debug (Launch)-';
        var name = prefix + mainClass.substr(mainClass.lastIndexOf('.') + 1);
        if (projectName !== undefined) {
            name += "<" + projectName + ">";
        }
        if (cache[name] === undefined) {
            cache[name] = 0;
            return name;
        }
        cache[name] += 1;
        return name + "(" + cache[name] + ")";
    };
    PythonDebugAdapterContribution.prototype.resolveDebugConfiguration = function (config, workspaceFolderUri) {
        return __awaiter(this, void 0, void 0, function () {
            var mainClassOption, debugServerPort, ex_1, errorMessage;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 5, , 6]);
                        if (!(config.request === 'launch')) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.resolveLaunchConfig(config, workspaceFolderUri)];
                    case 1:
                        mainClassOption = _a.sent();
                        if (!mainClassOption || !mainClassOption.mainClass) { // Exit silently if the user cancels the prompt fix by ESC.
                            // Exit the debug session.
                            return [2 /*return*/];
                        }
                        config.mainClass = mainClassOption.mainClass;
                        config.projectName = mainClassOption.projectName;
                        return [3 /*break*/, 3];
                    case 2:
                        if (config.request === 'attach') {
                            if (!config.hostName || !config.port) {
                                throw new Error('Please specify the host name and the port of the remote debuggee in the launch.json.');
                            }
                        }
                        else {
                            throw new Error("Request type \"" + config.request + "\" is not supported. Only \"launch\" and \"attach\" are supported.");
                        }
                        _a.label = 3;
                    case 3:
                        if (Array.isArray(config.args)) {
                            config.args = this.concatArgs(config.args);
                        }
                        if (Array.isArray(config.vmArgs)) {
                            config.vmArgs = this.concatArgs(config.vmArgs);
                        }
                        return [4 /*yield*/, this.startDebugSession()];
                    case 4:
                        debugServerPort = _a.sent();
                        if (debugServerPort) {
                            config.debugServer = debugServerPort;
                            return [2 /*return*/, config];
                        }
                        else {
                            throw new Error('Failed to start debug server.');
                        }
                        return [3 /*break*/, 6];
                    case 5:
                        ex_1 = _a.sent();
                        errorMessage = (ex_1 && ex_1.message) || ex_1;
                        this.messages.error(String(errorMessage));
                        return [2 /*return*/, undefined];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    PythonDebugAdapterContribution.prototype.resolveLaunchConfig = function (config, workspaceFolderUri) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, {
                        mainClass: config.mainClass,
                        projectName: config.projectName,
                    }];
            });
        });
    };
    PythonDebugAdapterContribution.prototype.fixMainClass = function (config, validationResponse, workspaceFolderUri) {
        return __awaiter(this, void 0, void 0, function () {
            var errors, message, proposals, answer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        errors = [];
                        if (!validationResponse.mainClass.isValid) {
                            errors.push(String(validationResponse.mainClass.message));
                        }
                        if (!validationResponse.projectName.isValid) {
                            errors.push(String(validationResponse.projectName.message));
                        }
                        message = errors.join('\n');
                        proposals = validationResponse.proposals || [];
                        if (!(validationResponse.proposals && validationResponse.proposals.length)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.messages.error(message, 'Fix')];
                    case 1:
                        answer = _a.sent();
                        return [2 /*return*/, answer === 'Fix' ? this.selectMainClass(proposals) : undefined];
                    case 2: throw new Error(message);
                }
            });
        });
    };
    PythonDebugAdapterContribution.prototype.selectMainClass = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.quickPickService.show(this.formatMainClassOptions(options), { placeholder: 'Select main class<project name>' })];
            });
        });
    };
    PythonDebugAdapterContribution.prototype.formatMainClassOptions = function (options) {
        return options.map(function (option) {
            var label = option.mainClass;
            var description = "main class: " + option.mainClass;
            if (option.projectName) {
                label += "<" + option.projectName + ">";
                description += " | project name: " + option.projectName;
            }
            return {
                label: label,
                description: description,
                value: option
            };
        });
    };
    PythonDebugAdapterContribution.prototype.startDebugSession = function () {
        return this.commands.executeCommand(VSCodePythonDebugCommands.START_DEBUG_SESSION);
    };
    /**
     * Converts an array of arguments to a string as the args and vmArgs.
     */
    PythonDebugAdapterContribution.prototype.concatArgs = function (args) {
        return _.join(_.map(args, function (arg) {
            var str = String(arg);
            // if it has quotes or spaces, use double quotes to wrap it
            if (/['"\s]/.test(str)) {
                return '"' + str.replace(/(['"\\])/g, '\\$1') + '"';
            }
            return str;
            // if it has only single quotes
        }), ' ');
    };
    __decorate([
        inversify_1.inject(common_1.CommandService),
        __metadata("design:type", Object)
    ], PythonDebugAdapterContribution.prototype, "commands", void 0);
    __decorate([
        inversify_1.inject(common_1.MessageService),
        __metadata("design:type", common_1.MessageService)
    ], PythonDebugAdapterContribution.prototype, "messages", void 0);
    __decorate([
        inversify_1.inject(quick_pick_service_1.QuickPickService),
        __metadata("design:type", Object)
    ], PythonDebugAdapterContribution.prototype, "quickPickService", void 0);
    PythonDebugAdapterContribution = __decorate([
        inversify_1.injectable()
    ], PythonDebugAdapterContribution);
    return PythonDebugAdapterContribution;
}(PythonDebugExtensionContribution));
exports.PythonDebugAdapterContribution = PythonDebugAdapterContribution;
//# sourceMappingURL=python-debug-adapter-contribution.js.map